package recursionsum;

import java.util.Scanner;
import java.util.InputMismatchException;

/**
 *
 * @author Carl
 */
public class RecursionSum
{

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args)
    {
        try
        {
            Scanner input = new Scanner(System.in);
            
            System.out.print("Sum of numbers 1 through?: ");
            int n = input.nextInt();
            
            System.out.println(sum(n) );
        }
        catch (InputMismatchException ex)
        {
            System.out.println(ex + ": Integer required");
        }
        catch (Exception ex)
        {
            System.out.println( ex.getMessage() );
        }
    }
    
    /**
     * Recursive method to return the sum of all numbers from 'n' to 1.
     * 
     * @param n the number from which the sum is generated
     * @return the sum of all numbers from 'n' to 1
     * @throws if input is zero (0) or negative
     */
    private static int sum(int n) throws Exception
    {
//        if (n <= 0)
//        {
//            throw new Exception("Zero (0) or negative values not allowed");
//        }
        
        if (n == 1)
        {
            return 1;
        }
        else
        {
            return n + sum(n - 1);
        }
    }
}
